import java.util.function.Function;

public class ParallelMap<X,Y> extends {

	ParallelMap(X[] source,
			Function<X,Y> func,
			Y[] target,
			int size) {
		this.source = source;
		this.func = func;
		this.target = target;
		this.size = size;
	}

	public class Applicator implements Runnable {
		int loc;
		Applicator(int loc) {
			this.loc = loc;
		}

		public void run() {
			target[loc] = func.apply(source[loc]); 
		}
	}

	public void map() {
		Thread[] threads = new Thread[size];

		for (int i=0 ; i<size ; i++) {
			threads[i] = new Thread(new Applicator(i));
			threads[i].start();
		}
		try {
			for (int i=0 ; i<size ; i++) {
				threads[i].join();
			} 
		} catch (InterruptedException e) {} 
	}
}
