import java.util.ArrayList;
import java.util.function.BinaryOperator;

public class Reduce<X> {

	protected ArrayList<X> source;
	protected BinaryOperator<X> func;
	protected X initial;
	
	Reduce(ArrayList<X> source,
		BinaryOperator<X> func,
		X initial) {
		this.source = source;
		this.func = func;
		this.initial = initial;
	}
	
	public X reduce() {
		X accumulator = initial;
		for (int i=0 ; i< source.size(); i++) {
			accumulator = func.apply(accumulator,source.get(i));
		}
		return accumulator;
	}	
	
	public static void main(String[] args)
	{
/*
		ArrayList<String> arr = new ArrayList<String>(7);
		arr.add("a");
		arr.add("b");
		arr.add("c");
		arr.add("d");
		arr.add("e");
		arr.add("f");
		arr.add("g");

		String s= new String();
		BinaryOperator<String> f = (String a, String b) -> a+b;
		Reduce<String> r = new Reduce<String>(arr,f,s);
		System.out.println(r.reduce());
		System.out.println("blah");
		System.out.println(s);
		System.out.println("blah");
*/
		ArrayList<Integer> arr = new ArrayList<Integer>(10);
		for (int i=1 ; i<12 ; i++) {
			arr.add(i);
		}

		Integer s=0;
		BinaryOperator<Integer> f = (Integer a, Integer b) -> a+b;
		Reduce<Integer> r = new Reduce<Integer>(arr,f,s);
		System.out.println(r.reduce());
		System.out.println("blah");
		System.out.println(s);
		System.out.println("blah");

	}
	
}
