import java.util.Arrays;


// Based on code taken from
// https://www.geeksforgeeks.org/merge-sort-with-o1-extra-space-merge-and-on-lg-n-time/
// Copied on 2023-08-21

// Java program to sort an array using merge sort

class MergeSort
{

	static class MergeSortParallel extends Thread {
		private int[] arr;
		private int low;
		private int high;
		private int[] space;

		MergeSortParallel(int[] arr, int low, int high, int[] space) {
			this.arr = arr;
			this.low = low;
			this.high = high;
			this.space = space;
		}

		public void run() {
			if (high - low <= 1) return;
			int mid = low + (high - low) / 2;
			Thread l = new MergeSortParallel(arr,low,mid,space);
			Thread r = new MergeSortParallel(arr,mid,high,space);

			l.start();
			r.start();

			try {
				l.join();
				r.join();
				merge(arr, low, mid, high, space);
			} catch (InterruptedException e) {

			}

		}
	}


	static void merge(int[] arr, int low, int mid, int high, int[] space)
	{
		int i = low; int j = mid; int k = low;
		while (i < mid && j < high)
		{
			if (arr[i] <= arr[j])
				space[k++] = arr[i++];
			else
				space[k++] = arr[j++];
		}
		while (i < mid)
			space[k++] = arr[i++];
		while (j < high)
			space[k++] = arr[j++];

		for (i = low; i < high; i++)
			arr[i] = space[i];
	}

	// Recursive merge sort
	private static void mergeSortRec(int[] arr, int low, int high, int[] space)
	{
		if (high - low <= 1) return;
		int mid = low + (high - low) / 2;
		mergeSortRec(arr, low, mid, space);
		mergeSortRec(arr, mid, high, space);
		merge(arr, low, mid, high, space);
	}

	// This function calls recursive merge sort.
	public static void mergeSort(int[] arr, int size)
	{
		int[] space = new int[size];
		MergeSortParallel m = new MergeSortParallel(arr,0,size,space);
		m.run();
//		mergeSortRec(arr, 0, size, space);
	}

	// Driver code
	public static void main(String[] args)
	{

		int[] arr = {1,2,3,4,5,6,7,999, 612, 589,1,2,3,4,5,6,7,999, 612, 589,1,2,3,4,5,6,7,999, 612, 589,1,2,3,4,5,6,7,999, 612, 589,
				856, 56, 945, 243};
		int n = arr.length;

		for (int i=0 ; i<n ; i++) {
			arr[i]=(int)(Math.random() * 1001);
		}

		mergeSort(arr, n);

		System.out.println("Sorted array ");
		for (int i = 0; i < n; i++)
		{
			System.out.print(arr[i] + " ");
		}
	}
}